﻿Imports System.IO.IsolatedStorage
Imports System.IO

Partial Public Class MainPage
    Inherits PhoneApplicationPage
    ' Constructor
    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub AppBar_Add_Click(ByVal sender As Object, ByVal e As EventArgs)
        NavigationService.Navigate(New Uri("/XapNote;component/Add.xaml", UriKind.Relative))

        '            
        '             *  I created this as an easy way to get a single file
        '             *  into the IsolatedStorage for testing it.
        '
        '               Dim fileName = "2010_10_06_13_43_01_Redmond_Washington-USA.txt"
        '               Dim fileContent = "This is just a test to see if I can get this to work!"

        '               Dim appStorage = IsolatedStorageFile.GetUserStoreForApplication()

        '               If Not appStorage.FileExists(fileName) Then
        '                   Using file = appStorage.CreateFile(fileName)
        '                      Using writer = New StreamWriter(file)
        '                            writer.WriteLine(fileContent)
        '                       End Using
        '                 End Using
        '               End If

        '               bindList()
        '             * 
        '            

    End Sub

    Private Sub PhoneApplicationPage_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
        bindList()
    End Sub

    Private Sub bindList()
        Dim appStorage = IsolatedStorageFile.GetUserStoreForApplication()

        Dim fileList() = appStorage.GetFileNames()

        Dim notes As New List(Of Note)

        For Each file In fileList
            ' Retrieve the file
            Dim fileName = file

            ' Pluck out the date parts
            Dim year = file.Substring(0, 4)
            Dim month = file.Substring(5, 2)
            Dim day = file.Substring(8, 2)
            Dim hour = file.Substring(11, 2)
            Dim minute = file.Substring(14, 2)
            Dim second = file.Substring(17, 2)

            ' Create a new DateTime object
            Dim dateCreated As New Date(Integer.Parse(year), Integer.Parse(month), Integer.Parse(day),
                                        Integer.Parse(hour), Integer.Parse(minute), Integer.Parse(second))

            ' Parse out the location
            Dim location = file.Substring(20)
            location = location.Replace("_", ", ")
            location = location.Replace("-", " ")
            location = location.Substring(0, location.Length - 4)

            notes.Add(New Note With {.Location = location, .DateCreated = dateCreated.ToLongDateString(), .FileName = fileName})
        Next file

        noteListBox.ItemsSource = notes
    End Sub

    Private Sub noteLocation_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim clickedLink = CType(sender, HyperlinkButton)

        Dim uri = String.Format("/XapNote;component/ViewEdit.xaml?id={0}", clickedLink.Tag)

        NavigationService.Navigate(New Uri(uri, UriKind.Relative))
    End Sub

End Class

